//<head>//////////////////////////////////////////////////////////////
//
//	
//	Lexed version 4.0
//	Copyright (C) 1999 2000 2001 2002 2003.
//	Universit Paris 7
//	INRIA Rocquencourt
//
//	Conception & programmation :
//	Lionel Clment
//	e-mail : lionel.clement@linguist.jussieu.fr
//
//	vendredi 18 janvier 2002, 13h41
//
//
////////////////////////////////////////////////////////////////</head>////

#ifndef LEXEDTREE_H
#define LEXEDTREE_H

//#define BUG {fprintf (stderr, "*** Bug %s(%d)\n", __FILE__, __LINE__);}

typedef unsigned long int TYPEPTR;

#define LEXEDMAXSTRING 4096
#define LEXEDMAXREPLACE 64
#define LEXEDMAXRESULT 64 // pour les recherches approx pas de panique: au del on raloue

#include "lexedtcp.h"
#include "lexedinfo.h"

struct FindReplaceStructure {
  char *Find;
  char *Repl;
};

////////////////////////////////////////////////////////////
// input: info
// output: sending results to stdout/client
////////////////////////////////////////////////////////////
void PrintResults (TYPEPTR Index,
		   int ClientServer, 
		   TcpServer *server, 
		   int Sep);

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
void sPrintResults (TYPEPTR Index,
		    char ***Result,
		    int *ResultSize,
		    int *ResultIndex);

////////////////////////////////////////////////////////////
// input:
// output: lexicon
////////////////////////////////////////////////////////////
void List(TYPEPTR Index,
	  int ClientServer, 
	  TcpServer *server, 
	  char *Chaine,
	  int Rang);

////////////////////////////////////////////////////////////
// input: chaine
// output: info
////////////////////////////////////////////////////////////
TYPEPTR SearchStatic(TYPEPTR Index,
		      char *Chaine);

////////////////////////////////////////////////////////////
// input: string
// output: info
////////////////////////////////////////////////////////////
void Search(TYPEPTR Index,				// the index in the tree
	    int ClientServer, 				// if there are a socket connexion
	    TcpServer *server, 				// the server for a socket connexion
	    char *Chaine,				// the string to find
	    int NbreApproxErase,			// number of chars to erase
	    int NbreApproxSubstitute, 			// number of chars to subst
	    int NbreApproxAdd, 				// number of chars to add
	    int NbreApproxSwap, 			// number of chars to swap
	    int NbreApproxEraseDouble, 			// number of times a double is erased
	    int NbreApproxAddDouble, 			// number of times a double is add
	    int NbreApproxReplace,			// number of chars to replace
	    struct FindReplaceStructure *Replace,	// couples (char *search, char *replace) -- (sets of chars)
	    int AlreadyModified,			// leng of the prefix of the rest already changed (to do not modify a char)
	    TYPEPTR **Result, 
	    int *ResultSize,
	    int *ResultIndex,
	    TYPEPTR Weight);

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
SaveFSA(FILE *Fichier);

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
LoadFSA(FILE *Fichier);

struct Fsa {
  public:
  TYPEPTR fils;
  TYPEPTR frere;
  TYPEPTR info;
  int car;
} ;

class Arbre
{
public:
  Arbre *fils;
  Arbre *frere;
  Info *info;
  int car;

  TYPEPTR adress;
  
  Arbre(Arbre *Fils,
	Arbre *Frere,
	Info *Info,
	unsigned int Car)
    {
      adress=0;
      fils = Fils;
      frere = Frere;
      info = Info;
      car = Car;
    };
  
  ~Arbre() {};

  void Add(char *, 
	   TYPEPTR);
  void SetIndexStaticFSA(unsigned long int &);
  void PrintStaticFSA(FILE *);
  void SetIndexStaticInfo(unsigned long int &);
  void PrintStaticInfo(FILE *);
};

#endif // LEXEDTREE_
